Package: ncRNAtools
Type: Package
Title: An R toolkit for non-coding RNA
Version: 1.22.1
Date: 2021-06-27
Authors@R: c(
    person("Lara", "Selles Vidal", email = "lara.selles@oist.jp", role = c("cre", "aut"), comment = c(ORCID = "0000-0003-2537-6824")),
    person("Rafael", "Ayala", email = "rafael.ayala@oist.jp", role = "aut", comment = c(ORCID = "0000-0002-9332-4623")),
    person("Guy-Bart", "Stan", email = "g.stan@imperial.ac.uk", role = "aut", comment = c(ORCID = "0000-0002-5560-902X")),
    person("Rodrigo", "Ledesma-Amaro", email = "r.ledesma-amaro@imperial.ac.uk", role = "aut", comment = c(ORCID = "0000-0003-2631-5898")))
Description: ncRNAtools provides a set of basic tools for handling and 
    analyzing non-coding RNAs. These include tools to access the RNAcentral
    database and to predict and visualize the secondary structure of non-coding
    RNAs. The package also provides tools to read, write and interconvert the 
    file formats most commonly used for representing such secondary structures.
License: GPL-3
Imports: httr, xml2, utils, methods, grDevices, ggplot2, IRanges,
        GenomicRanges, S4Vectors
Suggests: knitr, BiocStyle, rmarkdown, RUnit, BiocGenerics
VignetteBuilder: knitr
biocViews: FunctionalGenomics, DataImport, ThirdPartyClient,
        Visualization, StructuralPrediction
NeedsCompilation: no
Encoding: UTF-8
BugReports: https://github.com/LaraSellesVidal/ncRNAtools/issues
git_url: https://git.bioconductor.org/packages/ncRNAtools
git_branch: RELEASE_3_23
git_last_commit: bbd3081
git_last_commit_date: 2026-04-29
Repository: Bioconductor 3.23
Date/Publication: 2026-04-30
Packaged: 2026-04-30 23:14:06 UTC; biocbuild
Author: Lara Selles Vidal [cre, aut] (ORCID:
    <https://orcid.org/0000-0003-2537-6824>),
  Rafael Ayala [aut] (ORCID: <https://orcid.org/0000-0002-9332-4623>),
  Guy-Bart Stan [aut] (ORCID: <https://orcid.org/0000-0002-5560-902X>),
  Rodrigo Ledesma-Amaro [aut] (ORCID:
    <https://orcid.org/0000-0003-2631-5898>)
Maintainer: Lara Selles Vidal <lara.selles@oist.jp>

rnaCentralEbiApiURL <- 'https://www.ebi.ac.uk/ebisearch/ws/rest/rnacentral'
rnaCentralApiURL <- 'https://rnacentral.org/api/v1/rna'
rnaCentralRangeSearchURL <- 'https://rnacentral.org/api/v1/overlap/region'

rtoolsBaseURL <- 'https://www.ncrna.org/rtools/'

globalVariables(c("nucleotide1", "nucleotide2", "probability"))

localOS <- Sys.info()["sysname"]

## ----setup, echo=FALSE--------------------------------------------------------
knitr::opts_chunk$set(message=FALSE, fig.path='figures/')

## ----tidy = TRUE, eval = FALSE------------------------------------------------
# if (!requireNamespace("BiocManager", quietly = TRUE))
#     install.packages("BiocManager")
# 
# # The following line initializes usage of Bioc devel, and therefore should be
# # skipped in order to install the stable release version
# BiocManager::install(version='devel')
# 
# BiocManager::install("ncRNAtools")

## ----include = FALSE----------------------------------------------------------
library(ncRNAtools)
library(GenomicRanges)
library(IRanges)
library(S4Vectors)
library(ggplot2)

## ----tidy = TRUE--------------------------------------------------------------
rnaCentralTextSearch("HOTAIR")

## ----tidy = TRUE--------------------------------------------------------------
rnaCentralTextSearch("FMN AND species:\"Bacillus subtilis\"")

## ----tidy = TRUE--------------------------------------------------------------
rnaCentralRetrieveEntry("URS000037084E_1423")

## ----tidy = TRUE, tidy.opts=list(width.cutoff = 80)---------------------------
## Generate a GRanges object with the genomic ranges to be used to search the RNAcentral database

genomicCoordinates <- GenomicRanges::GRanges(seqnames=S4Vectors::Rle(c("chrC", "chrD")), 
                                             ranges=IRanges::IRanges(c(200000, 500000), c(300000, 550000)))

## Use the generated GRanges object to search the RNAcentral database

RNAcentralHits <- rnaCentralGenomicCoordinatesSearch(genomicCoordinates, "Yarrowia lipolytica")

## Check the number of hits in each provided genomic range

length(RNAcentralHits[[1]]) # 22 known ncRNA between positions 200000 and 300000 of chromosome C
length(RNAcentralHits[[2]]) # No known ncRNA between positions 500000 and 550000 of chromosome D


## ----tidy = TRUE--------------------------------------------------------------
tRNAfragment <- "UGCGAGAGGCACAGGGUUCGAUUCCCUGCAUCUCCA"

centroidFoldPrediction <- predictSecondaryStructure(tRNAfragment, "centroidFold")
centroidFoldPrediction$secondaryStructure

centroidHomFoldPrediction <- predictSecondaryStructure(tRNAfragment, "centroidHomFold")
centroidFoldPrediction$secondaryStructure

IPknotPrediction <- predictSecondaryStructure(tRNAfragment, "IPknot")
IPknotPrediction$secondaryStructure

## ----tidy = TRUE--------------------------------------------------------------
tRNAfragment2 <- "AAAGGGGUUUCCC"

RintWPrediction <- predictAlternativeSecondaryStructures(tRNAfragment2)

length(RintWPrediction) # A total of 2 alternative secondary structures were identified by RintW

RintWPrediction[[1]]$secondaryStructure
RintWPrediction[[2]]$secondaryStructure

## ----tidy = TRUE--------------------------------------------------------------
basePairProbabilityMatrix <- generatePairsProbabilityMatrix(centroidFoldPrediction$basePairProbabilities)

plotPairsProbabilityMatrix(basePairProbabilityMatrix)

## ----tidy = TRUE--------------------------------------------------------------
pairedBases <- findPairedBases(sequence=tRNAfragment, secondaryStructureString=IPknotPrediction$secondaryStructure)

plotCompositePairsMatrix(basePairProbabilityMatrix, pairedBases)

## ----tidy = TRUE--------------------------------------------------------------
## Read an example CT file corresponding to E. coli tmRNA

exampleCTFile <- system.file("extdata", "exampleCT.ct", package="ncRNAtools")

tmRNASequence <- "GGGGCUGAUUCUGGAUUCGACGGGAUUUGCGAAACCCAAGGUGCAUGCCGAGGGGCGGUUGGCCUCGUAAAAAGCCGCAAAAAAUAGUCGCAAACGACGAAAACUACGCUUUAGCAGCUUAAUAACCUGCUUAGAGCCCUCUCUCCCUAGCCUCCGCUCUUAGGACGGGGAUCAAGAGAGGUCAAACCCAAAAGAGAUCGCGUGGAAGCCCUGCCUGGGGUUGAAGCGUUAAAACUUAAUCAGGCUAGUUUGUUAGUGGCGUGUCCGUCCGCAGCUGGCAAGCGAAUGUAAAGACUGACUAAGCAUGUAGUACCGAGGAUGUAGGAAUUUCGGACGCGGGUUCAACUCCCGCCAGCUCCACCA"

tmRNASecondaryStructure <- readCT(exampleCTFile, tmRNASequence)

## Write a complete CT file for E. coli tmRNA

tempDir <- tempdir()
testCTFile <- paste(tempDir, "testCTfile.ct", sep="")

tmRNASecondaryStructureString <- pairsToSecondaryStructure(pairedBases=tmRNASecondaryStructure$pairsTable, sequence=tmRNASequence)

writeCT(testCTFile, sequence=tmRNASequence, 
        secondaryStructure=tmRNASecondaryStructureString, sequenceName="tmRNA")

## Read an example Dot-Bracket file

exampleDotBracketFile <- system.file("extdata", "exampleDotBracket.dot", 
                                     package="ncRNAtools")

exampleDotBracket <- readDotBracket(exampleDotBracketFile)

exampleDotBracket$freeEnergy # The structure has a free energy of -41.2 kcal/mol

## Write a Dot-Bracket file

tempDir2 <- tempdir()
testDotBracketFile <- paste(tempDir2, "testDotBracketFile.dot", sep="")

writeDotBracket(testDotBracketFile, sequence=exampleDotBracket$sequence, 
                secondaryStructure=exampleDotBracket$secondaryStructure, 
                sequenceName="Test sequence")

## ----tidy = TRUE--------------------------------------------------------------
extendedDotBracketString <- "...((((..[[[.))))]]]..."

plainDotBracketString <- flattenDotBracket(extendedDotBracketString)

## ----tidy = TRUE--------------------------------------------------------------
sessionInfo()

sendSecondaryStructureQuery <- function(sequence, method, gammaWeight, inferenceEngine,
                                        alignmentEngine, eValueRfamSearch, numHomSeqsRfamSearch) {
  registerURL <- paste(rtoolsBaseURL, "register.cgi", sep="")
  methodCode <- match(method, c("centroidFold", "centroidHomFold", "IPknot"))
  if (is.na(methodCode)) {
    stop("Invalid method for secondary structure prediction")
  }
  formData <- list(query=paste(">", "Sequence", "\n", sequence, sep="", collapse=""),
                   methodSelection="checked",
                   model_str_1="CONTRAfold",
                   gamma_1="4",
                   model_str_2="BL",
                   model_aln_2="CONTRAlign",
                   gamma_2="8",
                   eval_2="0.01",
                   homnum_2="30",
                   model_str_3="BL",
                   gamma_3="4")
  if (!is.null(gammaWeight)) {
    checkGammaWeight(gammaWeight)
    formData[c("gamma_1", "gamma_2", "gamma_3")] <- as.character(gammaWeight)
  }
  if (!is.null(inferenceEngine)) {
    checkInferenceEngine(inferenceEngine, method, sequence)
    formData[c("model_str_1", "model_str_2", "model_str_3")] <- inferenceEngine
  }
  if (!is.null(alignmentEngine)) {
    checkAlignmentEngine(alignmentEngine, method)
    formData["model_aln_2"] <- alignmentEngine
  }
  if (!is.null(eValueRfamSearch)) {
    checkEValueRfamSearch(eValueRfamSearch, method)
    formData["eval_2"] <- as.character(eValueRfamSearch)
  }
  if (!is.null(numHomSeqsRfamSearch)) {
    checkNumHomSeqsRfamSearch(numHomSeqsRfamSearch, method)
    formData["homnum_2"] <- as.character(numHomSeqsRfamSearch)
  }
  names(formData)[2] <- paste("exec_sel_", methodCode, sep="")
  response <- POST(registerURL,
                   body=formData,
                   encode="form",
                   add_headers("Content-Type"="application/x-www-form-urlencoded",
                               "Upgrade-Insecure-Requests"="1",
                               "Accept"="*/*"))
  redirectURL <- response$all_headers[[1]]$headers$location
  requestID <- splitString(redirectURL, split="req_id=")[2]
  return(c(requestID, methodCode))
}

sendAlternativeSecondaryStructureQuery <- function(sequence, gammaWeight, inferenceEngine) {
  registerURL <- paste(rtoolsBaseURL, "register.cgi", sep="")
  formData <- list(query=paste(">", "Sequence", "\n", sequence, sep="", collapse=""),
                   exec_sel_8="checked",
                   model_str_8=inferenceEngine,
                   gamma_8=gammaWeight)
  response <- POST(registerURL,
                   body=formData,
                   encode="form",
                   add_headers("Content-Type"="application/x-www-form-urlencoded",
                               "Upgrade-Insecure-Requests"="1",
                               "Accept"="*/*"))
  redirectURL <- response$all_headers[[1]]$headers$location
  requestID <- splitString(redirectURL, split="req_id=")[2]
  return(requestID)
}

checkSecondaryStructureQuery <- function(requestID) {
  secondaryStructureURL <- paste(rtoolsBaseURL, "result.cgi?req_id=", 
                                 requestID, sep="")
  queryResponse <- content(GET(secondaryStructureURL), as="text", encoding="UTF-8")
  queryRunning <- !grepl("Completed", queryResponse)
  if (queryRunning) {
    message("Secondary structure prediction is running, please wait.")
    return(queryRunning)
  }
  else if (!queryRunning) {
    message("Secondary structure prediction completed.")
    return(queryRunning)
  }
  else {
    stop("Malformed query or server unavailable. Please try again.")
  }
}

retrieveSecondaryStructureResults <-function(requestID, methodCode) {
  secondaryStructureURL <- paste(rtoolsBaseURL, "work/", requestID, "/", 
                                 methodCode, "/structure.txt", sep="")
  secondaryStructureResponseContent <- content(GET(secondaryStructureURL), as="text", encoding="UTF-8")
  secondaryStructure <- list(sequence=splitString(secondaryStructureResponseContent, split="\n")[2],
                             secondaryStructure=splitString(splitString(secondaryStructureResponseContent, split="\n")[3], split=" ")[1])
  if(methodCode %in% c(1, 2)) {
    basePairProbsURL <- paste(rtoolsBaseURL, "work/", requestID, "/", 
                              methodCode, "/base-pairing-prob.txt", sep="")
    basePairProbsResponseContent <- content(GET(basePairProbsURL), as="text", encoding="UTF-8")
    maxFieldsNumber <- max(count.fields(textConnection(basePairProbsResponseContent), sep=" "))
    basePairProbsTable <- read.table(textConnection(basePairProbsResponseContent), 
                                     header=FALSE, 
                                     col.names=c("Position", "Nucleotide", paste0("Pairing", seq(1, maxFieldsNumber-2))), 
                                     fill = TRUE, sep=" ")
    return(list(sequence=secondaryStructure[["sequence"]], 
                secondaryStructure=secondaryStructure[["secondaryStructure"]],
                basePairProbabilities=basePairProbsTable[, -ncol(basePairProbsTable)]))
  }
  else {
    return(secondaryStructure)
  }
}

retrieveAlternativeSecondaryStructureResults <- function(requestID) {
  numberAltStructures <- sum(gregexpr("range of Hamming distance",
                                      xml_text(content(GET(paste(rtoolsBaseURL, "result.cgi?req_id=", requestID, sep="")), as="parsed")),
                                      fixed=TRUE)[[1]] > 0)
  if (numberAltStructures == 1) {
    message("No alternative structures were found. 
            Returning canonical structure.")
    canonicalStructureURL <- paste(rtoolsBaseURL, "work/", requestID, "/", "8", 
                                   "/rintw.range.", 1, ".ss.txt", sep="")
    canonicalStructureResponseContent <- content(GET(canonicalStructureURL), as="text", encoding="UTF-8")
    canonicalStructure <- list(sequence=splitString(canonicalStructureResponseContent, split="\n")[1],
                               secondaryStructure=splitString(canonicalStructureResponseContent, split="\n")[2])
    return(canonicalStructure)
  }
  alternativeStructures <- vector(mode="list", length=numberAltStructures)
  for (i in seq_len(numberAltStructures)){
    altStructureURL <- paste(rtoolsBaseURL, "work/", requestID, "/", "8", 
                             "/rintw.range.", i, ".ss.txt", sep="")
    altStructureResponseContent <- content(GET(altStructureURL), as="text", encoding="UTF-8")
    alternativeStructures[[i]] <- list(sequence=splitString(altStructureResponseContent, split="\n")[1],
                                       secondaryStructure=splitString(altStructureResponseContent, split="\n")[2])
  }
  names(alternativeStructures) <- c("alternativeStructure1-Canonical", 
                                    paste("alternativeStructure", seq(2, numberAltStructures), sep=""))
  return(alternativeStructures)
}

extractBasePairProbability <- function(basePairProbsTableField) {
  if (basePairProbsTableField != "") {
    basePairProb <- as.numeric(splitString(basePairProbsTableField, split=":"))
    names(basePairProb) <- c("targetPosition", "probability")
    return(basePairProb)
  }
}

makeCompositeMatrix <-function(basePairProbsMatrix, pairedBases) {
  compositeMatrix <- basePairProbsMatrix
  compositeMatrix[upper.tri(compositeMatrix)] <- 0
  for (row in seq_len(nrow(pairedBases))) {
    compositeMatrix[pairedBases[row, "Position1"], pairedBases[row, "Position2"]] <- 1
  }
  return(compositeMatrix)
}

flattenDotBracket <- function(extendedDotBracketString) {
  extendedDotBracketVector <- splitString(extendedDotBracketString, "")
  simpleDotBracketVector <- character(length=length(extendedDotBracketVector))
  for (i in seq_len(length(extendedDotBracketVector))) {
    if (extendedDotBracketVector[i] %in% c("(", "[", "<", "{", "A", "B", "C", "D")) {
      simpleDotBracketVector[i] <- "("
    } else if (extendedDotBracketVector[i] %in% c(")", "]", ">", "}", "a", "b", "c", "d")) {
      simpleDotBracketVector[i] <- ")"
    } else if (extendedDotBracketVector[i] == ".") {
      simpleDotBracketVector[i] <- "."
    } else {
      stop("Invalid characters present in extended Dot-Bracket string")
    }
  }
  return(paste(simpleDotBracketVector, collapse=""))
}

splitString <- function(string, split, ...) {
  return(unlist(strsplit(string, split=split, ...)))
}

removeNewLines <- function(string) {
  return(gsub("[\r\n]", "", string))
}

plotPairsProbabilityMatrix <- function(basePairProbsMatrix, probabilityThreshold=0.1,
                                       colorPalette=paste(rainbow(7, rev=TRUE), "FF", sep="")) {
  meltedData <- data.frame(nucleotide1=factor(rownames(basePairProbsMatrix)[row(basePairProbsMatrix)],
                                              levels=rownames(basePairProbsMatrix)),
                           nucleotide2=factor(colnames(basePairProbsMatrix)[col(basePairProbsMatrix)],
                                              levels=colnames(basePairProbsMatrix)),
                           probability=as.vector(basePairProbsMatrix), 
                           row.names=NULL, stringsAsFactors=TRUE)
  plot <- ggplot(data = meltedData, aes(x=nucleotide1, y=nucleotide2, fill=probability)) +
    geom_abline(intercept=nrow(basePairProbsMatrix)+1,
                slope=-1,
                colour="darkgrey") +
    geom_hline(yintercept=(seq(nrow(basePairProbsMatrix), 0, by=-10)+1),
               color="lightgrey",
               size=0.2) +
    geom_vline(xintercept=seq(10, nrow(basePairProbsMatrix), by=10),
               color="lightgrey",
               size=0.2) +
    geom_tile() +
    scale_fill_gradientn(colours=c("#FFFFFF00", colorPalette),
                         values=c(0, seq(probabilityThreshold, 1, 
                                         length.out=length(colorPalette))),
                         breaks=c(0, 0.5, 1),
                         labels=c(0, 0.5, 1),
                         limits=c(0, 1),
                         name="Probability") +
    scale_x_discrete(position="top",
                     breaks=levels(meltedData$nucleotide1)[seq(10, nrow(basePairProbsMatrix), by=10)]) +
    scale_y_discrete(breaks=levels(meltedData$nucleotide1)[seq(10, nrow(basePairProbsMatrix), by=10)],
                     limits=rev(levels(meltedData$nucleotide2))) +
    coord_equal() +
    theme(panel.border=element_rect(colour = "black", fill=NA, size=1),
          panel.background = element_rect(fill="white"),
          plot.background = element_rect(fill = 'white', colour="white"),
          axis.title.x=element_blank(),
          axis.title.y=element_blank(),
          axis.text=element_text(color="black",size=12),
          axis.text.x = element_text(angle = 90))
  return(plot)
}

plotCompositePairsMatrix <- function(basePairProbsMatrix, pairedBases, probabilityThreshold=0.1,
                                     colorPalette=paste(rainbow(7, rev=TRUE), "FF", sep="")) {
  compositeMatrix <- makeCompositeMatrix(basePairProbsMatrix, pairedBases)
  compositeMatrix[upper.tri(compositeMatrix) & (compositeMatrix == 1)] <- NA
  meltedData <- data.frame(nucleotide1=factor(rownames(compositeMatrix)[row(compositeMatrix)],
                                              levels=rownames(compositeMatrix)),
                           nucleotide2=factor(colnames(compositeMatrix)[col(compositeMatrix)],
                                              levels=colnames(compositeMatrix)),
                           probability=as.vector(compositeMatrix), 
                           row.names=NULL, stringsAsFactors=TRUE)
  plot <- ggplot(data = meltedData, aes(x=nucleotide1, y=nucleotide2, fill=probability)) +
    geom_abline(intercept=nrow(basePairProbsMatrix)+1,
                slope=-1,
                colour="darkgrey") +
    geom_hline(yintercept=(seq(nrow(basePairProbsMatrix), 0, by=-10)+1),
               color="lightgrey",
               size=0.2) +
    geom_vline(xintercept=seq(10, nrow(basePairProbsMatrix), by=10),
               color="lightgrey",
               size=0.2) +
    geom_tile() +
    scale_fill_gradientn(colours=c("#FFFFFF00", colorPalette),
                         values=c(0, seq(probabilityThreshold, 1, 
                                         length.out=length(colorPalette))),
                         breaks=c(0, 0.5, 1),
                         labels=c(0, 0.5, 1),
                         limits=c(0, 1),
                         name="Probability",
                         na.value="black") +
    scale_x_discrete(position="top",
                     breaks=levels(meltedData$nucleotide1)[seq(10, nrow(basePairProbsMatrix), by=10)]) +
    scale_y_discrete(breaks=levels(meltedData$nucleotide1)[seq(10, nrow(basePairProbsMatrix), by=10)],
                     limits=rev(levels(meltedData$nucleotide2))) +
    coord_equal() +
    theme(panel.border=element_rect(colour = "black", fill=NA, size=1),
          panel.background = element_rect(fill="white"),
          plot.background = element_rect(fill = 'white', colour="white"),
          axis.title.x=element_blank(),
          axis.title.y=element_blank(),
          axis.text=element_text(color="black",size=12),
          axis.text.x = element_text(angle = 90))
  return(plot)
}

checkMultipleQuery <- function(inputString) {
  if (length(inputString) > 1) {
    stop("Multiple queries at a time not supported")
  }
}

checkInferenceEngine <- function(inferenceEngine, method, sequence) {
  if (method == "centroidFold" & !(inferenceEngine %in% c("CONTRAfold", "BL", "Turner"))) {
    stop(strwrap("Please select a secondary structure inference engine 
                 compatible with CentroidFold. See documentation for details", 
                 initial="", prefix="\n"))
  }
  else if (method == "centroidHomFold" & !(inferenceEngine %in% c("CONTRAfold", "BL", "Turner"))) {
    stop(strwrap("Please select a secondary structure inference engine 
                 compatible with CentroidHomfold. See documentation for
                 details", initial="", prefix="\n"))
  }
  else if (method == "IPknot" & !(inferenceEngine %in% c("CONTRAfold", "BL", "Turner", "NUPACK"))) {
    stop(strwrap("Please select a secondary structure inference engine 
                 compatible with IPknot. See documentation for details", 
                 initial="", prefix="\n"))
  }
  else if (method == "IPknot" & inferenceEngine == "NUPACK" & nchar(sequence)>100) {
    stop("NUPACK model is only available for sequences of 100 or less nucleotides.")
  }
}

checkAlignmentEngine <- function(alignmentEngine, method) {
  if (method != "centroidHomFold") {
    warning(strwrap("Alignment engine ignored, since CentroidHomfold was not
                    used for secondary structure prediction.", 
                    initial="", prefix="\n"))
  }
  else if (!alignmentEngine %in% c("CONTRAlign", "ProbCons")) {
    stop(strwrap("Please select a valid engine for pairwise alignment during 
                 CentroidHomfold prediction. See documentation for details.", 
                 initial="", prefix="\n"))
  }
}

checkGammaWeight <- function(gammaWeight) {
  if (!is.numeric(gammaWeight) || gammaWeight <= 0) {
    stop("Gamma weight must be a positive number.")
  }
}

checkEValueRfamSearch <- function(eValueRfamSearch, method) {
  if (method != "centroidHomFold") {
    warning(strwrap("E-value for searching the Rfam database ignored, since 
                    CentroidHomfold was not used for secondary structure prediction.",
                    initial="", prefix="\n"))
  }
  else if (!is.numeric(eValueRfamSearch) || eValueRfamSearch <= 0) {
    stop("E-value must be a positive number.")
  }
}

checkNumHomSeqsRfamSearch <- function(numHomSeqsRfamSearch, method) {
  if (method != "centroidHomFold") {
    warning(strwrap("Number of homolog sequences for searching the Rfam database
                    ignored, since CentroidHomfold was not used for secondary 
                    structure prediction.", initial="", prefix="\n"))
  }
  else if (!is.numeric(numHomSeqsRfamSearch) || numHomSeqsRfamSearch <= 0) {
    stop("The number of homolog sequences must be a positive number.")
  }
}

checkRNAString <- function(inputString) {
  if(!grepl('^[AUGCaugc]+$', gsub("[\r\n]", "", inputString))) {
    stop("Please provide a sequence string containing only standard RNA symbols")
  }
}

checkBasicDotBracketString <- function(inputString) {
  if(!grepl('^[\\(\\)\\.]+$', gsub("[\r\n]", "", inputString))) {
    stop("Please provide a secondary structure string in the basic Dot-Bracket 
         notation.")
  }
}

rnaCentralTextSearch <- function(query) {
  if (!is.character(query)) {
    stop("Input query is not a string")
  }
  if(localOS == "Linux") {
    httrConfig <- config(ssl_cipher_list="DEFAULT@SECLEVEL=1")
    result <- with_config(config=httrConfig, GET(rnaCentralEbiApiURL,
                                                 query=list(query=query,
                                                            format="idlist")))
  }
  else {
    result <- GET(rnaCentralEbiApiURL,
                  query=list(query=query,
                             format="idlist"))
  }
  matchList <- splitString(content(result, as="text"), split="\n")
  return(matchList[grep("^URS", matchList)])
}

rnaCentralRetrieveEntry <- function(rnaCentralID) {
  checkMultipleQuery(rnaCentralID)
  if (!grep("^URS", rnaCentralID)) {
    stop("Invalid RNAcentral ID provided.")
  }
  if(localOS == "Linux") {
    httrConfig <- config(ssl_cipher_list="DEFAULT@SECLEVEL=1")
    result <- with_config(config=httrConfig, GET(paste(rnaCentralApiURL, "/", 
                                                       rnaCentralID, sep=""),
                                                 accept_json()))
  }
  else {
    result <- GET(paste(rnaCentralApiURL, "/", rnaCentralID, sep=""),
                  accept_json())
  }
  resultContent <- content(result, as="parsed", type="application/json")
  parsedResult <- list(rnaCentralID=resultContent$rnacentral_id,
                       sequence=resultContent$sequence,
                       sequenceLength=resultContent$length,
                       description=resultContent$description,
                       species=resultContent$species,
                       ncbiTaxID=resultContent$taxid,
                       RNATypes=unlist(resultContent$ncrna_types))
  return(parsedResult)
}

rnaCentralGenomicCoordinatesSearch <- function(genomicRanges, species) {
  if (!is(genomicRanges, "GRanges")) {
    stop("Please provide a valid GRanges object with genomic coordinates.")
  }
  if (length(strsplit(species, split=" ")[[1]]) != 2) {
    stop("Please enter a valid species name. See documentation for details.")
  }
  speciesString <- gsub(" ", "_", tolower(species))
  chromosomes <- gsub("chr", "", as.character(seqnames(genomicRanges)))
  if (any(grepl("[^[:alnum:]]", chromosomes) & chromosomes != "MT")) {
    stop(strwrap("Please enter valid chromosome names as seqnames for the GRanges
                 object. See documentation for details.", initial="", prefix="\n"))
  }
  startPoints <- start(genomicRanges)
  endPoints <- end(genomicRanges)
  annotatedRNA <- vector(mode="list", length=length(genomicRanges))
  for (i in seq_len(length(genomicRanges))) {
    if(localOS == "Linux") {
      httrConfig <- config(ssl_cipher_list="DEFAULT@SECLEVEL=1")
      result <- with_config(config=httrConfig, GET(paste(rnaCentralRangeSearchURL, "/", speciesString, "/", chromosomes[i],
                                                         ":", startPoints[i], "-", endPoints[i], sep=""),
                                                   accept_json()))
    }
    else {
      result <- GET(paste(rnaCentralRangeSearchURL, "/", speciesString, "/", chromosomes[i],
                          ":", startPoints[i], "-", endPoints[i], sep=""),
                    accept_json())
    }
    parsedResult <- content(result, as="parsed", type="application/json")
    parsedResult <- parsedResult[grepl("^URS", unlist(lapply(parsedResult, `[`, "external_name")))]
    annotatedRNA[[i]] <- lapply(parsedResult, function(hit) list(rnaCentralID=splitString(hit$ID, split="@")[1],
                                                                 species=species,
                                                                 description=hit$description,
                                                                 RNAType=hit$biotype,
                                                                 genomicCoordinates=GRanges(seqnames=Rle(chromosomes[i]),
                                                                                            ranges=IRanges(hit$start, hit$end),
                                                                                            strand=splitString(hit$ID, split=":")[2])))
  }
  if (length(genomicRanges == 1)) {
    annotatedRNA <- unlist(annotatedRNA, recursive=FALSE)
  }
  return(annotatedRNA)
}

library(RUnit)
library(GenomicRanges)
library(IRanges)
library(S4Vectors)

## Test rnaCentralTextSearch

checkTrue(grepl("^URS", rnaCentralTextSearch("HOTAIR")[1]))

## Test rnaCentralRetrieveEntry

checkEquals("URS000075C808_9606", rnaCentralRetrieveEntry("URS000075C808_9606")$rnaCentralID)

## Test rnaCentralGenomicCoordinatesSearch

checkTrue(grepl("^URS", rnaCentralGenomicCoordinatesSearch(GenomicRanges::GRanges(seqnames=S4Vectors::Rle("chr3"), ranges=IRanges::IRanges(39788104, 39795326)), "Homo sapiens")[[1]][[1]]$rnaCentralID))

predictSecondaryStructure <- function(sequence, method, gammaWeight=NULL, inferenceEngine=NULL,
                                      alignmentEngine=NULL, eValueRfamSearch=NULL, numHomSeqsRfamSearch=NULL) {
  sequence <- removeNewLines(sequence)
  checkRNAString(sequence)
  sendQueryResult <- sendSecondaryStructureQuery(sequence, method, gammaWeight=gammaWeight, inferenceEngine=inferenceEngine,
                                                 alignmentEngine=alignmentEngine, eValueRfamSearch=eValueRfamSearch,
                                                 numHomSeqsRfamSearch=numHomSeqsRfamSearch)
  predictionFinished <- FALSE
  while (!predictionFinished) {
    Sys.sleep(1)
    queryRunning <- checkSecondaryStructureQuery(sendQueryResult[1])
    if (!queryRunning) {
      predictionFinished <- TRUE
    }
  }
  predictionResult <- retrieveSecondaryStructureResults(sendQueryResult[1], sendQueryResult[2])
  return(predictionResult)
}

predictAlternativeSecondaryStructures <- function(sequence, gammaWeight=4, inferenceEngine="BL") {
  sequence <- removeNewLines(sequence)
  checkRNAString(sequence)
  sendQueryResult <- sendAlternativeSecondaryStructureQuery(sequence, gammaWeight=gammaWeight, inferenceEngine=inferenceEngine)
  predictionFinished <- FALSE
  while (!predictionFinished) {
    Sys.sleep(3)
    queryRunning <- checkSecondaryStructureQuery(sendQueryResult)
    if (!queryRunning) {
      predictionFinished <- TRUE
    }
  }
  predictionResult <- retrieveAlternativeSecondaryStructureResults(sendQueryResult)
  return(predictionResult)
}

generatePairsProbabilityMatrix <- function(basePairProbsTable) {
  sequenceLength <- nrow(basePairProbsTable)
  sequenceNucleotides <- paste0(basePairProbsTable[, 2], seq_len(sequenceLength))
  basePairProbsMatrix <- matrix(0, nrow=sequenceLength, ncol=sequenceLength, 
                                dimnames=list(sequenceNucleotides, sequenceNucleotides))
  for (row in seq_len(nrow(basePairProbsTable))) {
    basePairProbabilitiesList <- lapply(basePairProbsTable[row, c(-1, -2)], 
                                        FUN=extractBasePairProbability)
    basePairProbabilitiesList <- basePairProbabilitiesList[lengths(basePairProbabilitiesList) != 0]
    pairedBasesPositions <- unlist(lapply(basePairProbabilitiesList, `[[`, 1))
    basePairProbabilities <- unlist(lapply(basePairProbabilitiesList, `[[`, 2))
    basePairProbsMatrix[row, pairedBasesPositions] <- basePairProbabilities
  }
  basePairProbsMatrix[lower.tri(basePairProbsMatrix)] <- t(basePairProbsMatrix)[lower.tri(basePairProbsMatrix)]
  return(basePairProbsMatrix)
}

findPairedBases <- function(secondaryStructureString, sequence) {
  sequence <- removeNewLines(sequence)
  checkBasicDotBracketString(secondaryStructureString)
  secondaryStructureCharacters <- splitString(secondaryStructureString, split="")
  sequenceCharacters <- splitString(sequence, split="")
  pairedBases <- data.frame(Position1=integer(), Position2=integer(),
                            Nucleotide1=character(), Nucleotide2=character())
  basePairsCount <- 0
  openBracketsPositions <- integer()
  openBracketsNucleotides <- character()
  for (i in seq(1, length(secondaryStructureCharacters))) {
    if (secondaryStructureCharacters[i] == "(") {
      openBracketsPositions <- c(openBracketsPositions, i)
      openBracketsNucleotides <- c(openBracketsNucleotides, sequenceCharacters[i])
    } else if (secondaryStructureCharacters[i] == ")") {
      basePairsCount <- basePairsCount + 1
      pairedBases[basePairsCount, "Position1"] <- openBracketsPositions[length(openBracketsPositions)]
      pairedBases[basePairsCount, "Position2"] <- i
      pairedBases[basePairsCount, "Nucleotide1"] <- openBracketsNucleotides[length(openBracketsNucleotides)]
      pairedBases[basePairsCount, "Nucleotide2"] <- sequenceCharacters[i]
      openBracketsPositions <- openBracketsPositions[-length(openBracketsPositions)]
      openBracketsNucleotides <- openBracketsNucleotides[-length(openBracketsNucleotides)]
    }
  }
  pairedBases <- pairedBases[order(pairedBases$Position1),]
  rownames(pairedBases) <- NULL
  return(pairedBases[order(pairedBases$Position1),])
}

pairsToSecondaryStructure <- function(pairedBases, sequence) {
  sequence <- removeNewLines(sequence)
  secondaryStructureString <- rep(".", nchar(sequence))
  secondaryStructureString[pairedBases[, "Position1"]] <- "("
  secondaryStructureString[pairedBases[, "Position2"]] <- ")"
  return(paste(secondaryStructureString, collapse=""))
}

library(RUnit)

testPrediction <- predictSecondaryStructure("UGCGAGAGGCACAGGGUUCGAUUCCCUGCAUCUCCA", "IPknot")
testAlternativePrediction <- predictAlternativeSecondaryStructures("A")
testBasePairProbabilitiesTable <- read.csv(system.file("extdata", "exampleBasePairProbabilitiesTable.csv", package="ncRNAtools"))
testPairedBases <- findPairedBases(testPrediction$secondaryStructure, testPrediction$sequence)

## Test predictSecondaryStructure

checkEquals(testPrediction$sequence, "UGCGAGAGGCACAGGGUUCGAUUCCCUGCAUCUCCA")

## Test predictAlternativeSecondaryStructures

checkEquals(testAlternativePrediction$sequence, "A")

## Test generatePairsProbabilityMatrix

checkTrue(is.matrix(generatePairsProbabilityMatrix(testBasePairProbabilitiesTable)))

## Test findPairedBases

checkTrue(is.data.frame(testPairedBases))

## Test pairsToSecondaryStructure

checkEquals(pairsToSecondaryStructure(testPairedBases, testPrediction$sequence), testPrediction$secondaryStructure)

readCT <- function(filename, sequence=NULL) {
  sequence <- removeNewLines(sequence)
  inputFile <- file(filename, "r")
  firstLine <- readLines(inputFile, n=1)
  connectivityTable <- read.table(inputFile)
  close(inputFile)
  firstLineFields <- splitString(firstLine, split="\\s", perl=TRUE)
  sequenceLength <- as.integer(firstLineFields[1])
  sequenceName <- firstLineFields[length(firstLineFields)]
  reconstructedSequence <- paste(connectivityTable[, 2], collapse="")
  if (nchar(reconstructedSequence) != sequenceLength) {
    if (is.null(sequence) || !(is.character(sequence) & nchar(sequence) == sequenceLength)) {
      stop(strwrap(prefix="\n", initial="", "CT file does not contain information
                   for all nucleotides. and a valid full-length sequence has not
                   been provided. Please provide either a complete CT file, or a
                   CT file with information only for paired bases and the
                   corresponding full-length RNA sequence."))
    }
    reconstructedSequence <- sequence
  }
  pairsTable <- connectivityTable[(connectivityTable[, 5] != 0) & (connectivityTable[, 5] > connectivityTable[, 1]), ]
  pairsTable <- pairsTable[, c(1, 5, 2)]
  complementaryNucleotides <- splitString(sequence, split="")[pairsTable[, 2]]
  pairsTable <- cbind(pairsTable, complementaryNucleotides)
  colnames(pairsTable) <- c("Position1", "Position2", "Nucleotide1", "Nucleotide2")
  resultsList <- list(sequenceName=sequenceName, sequence=sequence, 
                      sequenceLength=sequenceLength, pairsTable=pairsTable)
  return(resultsList)
}

readDotBracket <- function(filename) {
  inputFile <- file(filename, "r")
  firstLine <- readLines(inputFile, n=1)
  if (startsWith(firstLine, ">")) {
    sequenceName <- substring(firstLine, 2)
    sequence <- readLines(inputFile, n=1)
    structureLine <- readLines(inputFile, n=1)
    secondaryStructure <- splitString(structureLine, " ")[1]
    freeEnergy <- as.numeric(gsub("[^-+[:digit:]\\.]", "",
                                  splitString(structureLine, split=" ")[2]))
  }
  else {
    sequenceName <- NA
    sequence <- firstLine
    structureLine <- readLines(inputFile, n=1)
    secondaryStructure <- splitString(structureLine, " ")[1]
    freeEnergy <- as.numeric(gsub("[^-+[:digit:]\\.]", "",
                                  splitString(structureLine, " ")[2]))
  }
  close(inputFile)
  resultsList <- list(sequenceName=sequenceName, sequence=sequence,
                      secondaryStructure=secondaryStructure, freeEnergy=freeEnergy)
  return(resultsList)
}

writeCT <- function(filename, sequence, secondaryStructure=NULL, sequenceName="Sequence", pairedBases=NULL) {
  sequence <- removeNewLines(sequence)
  if (is.null(secondaryStructure) & is.null(pairedBases)) {
    stop("Please provide a secondary structure string or dataframe of paired bases.")
  } else if (!is.null(secondaryStructure) & is.null(pairedBases)) {
    pairsTable <- findPairedBases(secondaryStructure, sequence)
  } else {
    pairsTable <- pairedBases
  }
  outputFile <- file(filename, "w")
  writeLines(paste(nchar(sequence), sequenceName, sep="\t"), outputFile)
  for (i in seq_len(nchar(sequence))) {
    if (i %in% pairsTable[, 1]) {
      rowToWrite <- which(pairsTable[, 1] == i)
      writeLines(paste(i, substr(sequence, i, i), i-1, i+1, 
                       pairsTable[rowToWrite, 2], i, sep="\t"), 
                 outputFile)
    } else if (i %in% pairsTable[, 2]) {
      rowToWrite <- which(pairsTable[, 2] == i)
      writeLines(paste(i, substr(sequence, i, i), i-1, i+1, 
                       pairsTable[rowToWrite, 1], i, sep="\t"), 
                 outputFile)
    } else {
      writeLines(paste(i, substr(sequence, i, i), i-1, i+1, 0, i, sep="\t"), 
                 outputFile)
    }
  }
  close(outputFile)
}

writeDotBracket <- function(filename, sequence, secondaryStructure, 
                            sequenceName="Sequence") {
  sequence <- removeNewLines(sequence)
  outputFile <- file(filename, "w")
  writeLines(paste(">", sequenceName, sep=""), outputFile)
  writeLines(sequence, outputFile)
  writeLines(secondaryStructure, outputFile)
  close(outputFile)
}

library(RUnit)

## Test flattenDotBracket

checkEquals(flattenDotBracket("...((((..[[.))))]]"), "...((((..((.))))))")

## Test readCT

testCTFile <- system.file("extdata", "exampleCT.ct", package="ncRNAtools")
tmRNASequence <- "GGGGCUGAUUCUGGAUUCGACGGGAUUUGCGAAACCCAAGGUGCAUGCCGAGGGGCGGUUGGCCUCGUAAAAAGCCGCAAAAAAUAGUCGCAAACGACGAAAACUACGCUUUAGCAGCUUAAUAACCUGCUUAGAGCCCUCUCUCCCUAGCCUCCGCUCUUAGGACGGGGAUCAAGAGAGGUCAAACCCAAAAGAGAUCGCGUGGAAGCCCUGCCUGGGGUUGAAGCGUUAAAACUUAAUCAGGCUAGUUUGUUAGUGGCGUGUCCGUCCGCAGCUGGCAAGCGAAUGUAAAGACUGACUAAGCAUGUAGUACCGAGGAUGUAGGAAUUUCGGACGCGGGUUCAACUCCCGCCAGCUCCACCA"

checkTrue(nrow(readCT(testCTFile, tmRNASequence)$pairsTable) == 15)

## Test readDotBracket

testDotBracketFile <- system.file("extdata", "exampleDotBracket.dot", package="ncRNAtools")

checkTrue(readDotBracket(testDotBracketFile)$freeEnergy == -41.2)

---
bibliography: knitcitations.bib
csl: template.csl
css: mystyle.css
output:
  BiocStyle::html_document
vignette: |
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteIndexEntry{rfaRm}
  \usepackage[utf8]{inputenc}
---


```{r setup, echo=FALSE}
knitr::opts_chunk$set(message=FALSE, fig.path='figures/')
```

<!-- Title block -->
<br>
<p style="text-align:center;font-size:200%;color:Red"> ncRNAtools </p>
<p style="text-align:center;font-size:90%;color:Gray"> Lara Selles Vidal,
Rafael Ayala, Guy-Bart Stan, Rodrigo Ledesma-Amaro </p>
<p style="text-align:center;font-size:90%;color:Gray"> July 24, 2020 </p>
<br>

# Abstract
<p style="font-size:90%"> Non-coding RNA (ncRNA) comprise a variety of RNA 
molecules that are transcribed from DNA but are not translated into proteins.  
They include a large diversity of RNA which perform key cellular functions, 
including ribosomic RNA, transference RNA, ribozymes, small nuclear and small 
nucleolar RNA and multiple RNAs involved in the regulation of gene expression 
and chromatin structure, such as cis-regulatory elements, micro RNA,
interferenceRNA and long non-coding RNA. A key aspect in determining the 
function and properties of ncRNAs is their secondary structure. This package 
provides a set of tools for identifying ncRNAs of interest, determining and 
plotting their secondary structure and importing and exporting the most common 
file-types for ncRNA data.  <br><br> </p>

# Introduction

The key role of ncRNAs in cellular processes has been well established over the 
last two decades, with at least 70% of the human genome reported to be 
transcribed into RNAs of different sizes. Given the fact that only around 28% of
the human genome corresponds to protein-encoding regions (including introns and 
other untranslated regions), it is currently thought that the rest of the genome
encodes a high number of functional RNA molecules that are not translated to 
proteins [@fu2014].

One of the main characteristic features of ncRNAs is their secondary structure, 
defined by the intramolecular pairing of bases through hydrogen bonds. The 
identification of RNA secondary structure is often the basis for determining 
essential bases for ncRNA function, as well as for engineering novel or modified 
ncRNAs, including ribozymes. Furthermore, several methodologies for the 
prediction of RNA threedimensional structure require secondary structure 
information as a key input [@zhiyong2011; @thiel2017]. 

ncRNAtools aims to facilitate the inclusion of ncRNA identification and analysis
within existing genomics and transcriptomics workflows, as well as the 
application of statistical modeling for the prediction of ncRNA properties and 
structure by providing a set of tools for importing, exporting, plotting and 
analyzing ncRNAs and their features.

# Installation

To install ncRNAtools, start R (>=4.0) and run:

```{r tidy = TRUE, eval = FALSE}
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

# The following line initializes usage of Bioc devel, and therefore should be
# skipped in order to install the stable release version
BiocManager::install(version='devel')

BiocManager::install("ncRNAtools")
```

# Software features

A first set of ncRNAtools functionalities allows to search the [RNAcentral](https://rnacentral.org/) 
database of annotated ncRNA [@rnacentral2019]. The RNAcentral database can be 
searched in two different ways: by keywords, and by genomic coordinates. 
Information about a specific entry can also be retrieved.

ncRNAtools also enables the prediction of secondary structure of RNA by simply 
providing a sequence of interest. Secondary structure predictions are performed 
through the [rtools](https://www.ncrna.org/rtools/) web server for RNA Bioinformatics [@hamada2016]. 
Currently supported methodologies for secondary structure prediction include 
centroidFold [@hamada2008], centroidHomfold [@hamada2011] and IPknot [@sato2011]. 
Only IPknot can detect pseudoknots. Alternative secondary structures can be 
predicted with the RintW method [@hagio2018]. Utilities to determine paired 
bases from a secondary structure string and viceversa are also available.

Additionally, ncRNAtools provides utilities to calculate a matrix of base pair 
probabilities and visualize it as a heatmap, with the possibility to make a 
composite plot including also a defined secondary structure.

Finally, ncRNAtools supports reading and writing files in the CT and Dot-Bracket
formats, the two most commonly employed formats for storing the secondary 
structure of RNA.

# Examples

## Searching the RNAcentral database

The RNAcentral database can be searched by keywords with the "rnaCentralTextSearch"
function. The function returns a character vector where each element is a string
representing the RNAcentral accession for an entry that matched the search. 
RNAcentral accessions are always of either the "URSXXXXXXXXXX" form, where X is 
any hexadecimal numeral, or "URSXXXXXXXXXX_taxid", where taxid is the NCBI 
taxonomy identifier for the species or strain corresponding to the entry. 
Searches can either include only a keyword or phrase, or be given in the 
field_name:"field value" syntax, with several fields separated by logical 
operators as described in https://rnacentral.org/help/text-search. It should be 
noted that logical operators must be capitalized.

For example, the keyword "HOTAIR" can be passed as the query to the search 
function to identify entries corresponding to the HOTAIR ncRNA:

```{r include = FALSE}
library(ncRNAtools)
library(GenomicRanges)
library(IRanges)
library(S4Vectors)
library(ggplot2)
```

```{r tidy = TRUE}
rnaCentralTextSearch("HOTAIR")
```

With a more refined search, it is possible to identify RNAs corresponding to the
FMN riboswitch present in Bacillus subtilis strains only. It should be noted 
that the quotes enclosing the value for specific fields must be escaped:

```{r tidy = TRUE}
rnaCentralTextSearch("FMN AND species:\"Bacillus subtilis\"")
```

Information about the resulting entries can be retrieved with the 
"rnaCentralRetrieveEntry" function:

```{r tidy = TRUE}
rnaCentralRetrieveEntry("URS000037084E_1423")
```

It is also possible to perform a search of the RNAcentral database by specifying
genomic coordinates with the "rnaCentralGenomicCoordinatesSearch" function. 
A GRanges object must be provided, with sequence names of the **chr?** or simply
**?** format (where **?** denotes any number, the X or Y characters or another 
letter for organisms where chromosomes are named with letters), or, alternatively,
"MT" to denote mitochondrial DNA. The species name must also be provided as a 
string with the scientific name. A list of organisms for which search by genomic
coordinates is supported can be found at https://rnacentral.org/help/genomic-mapping. 
Several ranges can be provided in the same GRanges object, but they must refer
to the same organism.

In the following example, we aim to retrieve the known ncRNA present in Yarrowia
lipolytica (oleaginous yeast) between positions 200000 and 300000 of 
chromosome C, and positions 500000 and 550000 of chromosome D:

```{r tidy = TRUE, tidy.opts=list(width.cutoff = 80)}
## Generate a GRanges object with the genomic ranges to be used to search the RNAcentral database

genomicCoordinates <- GenomicRanges::GRanges(seqnames=S4Vectors::Rle(c("chrC", "chrD")), 
                                             ranges=IRanges::IRanges(c(200000, 500000), c(300000, 550000)))

## Use the generated GRanges object to search the RNAcentral database

RNAcentralHits <- rnaCentralGenomicCoordinatesSearch(genomicCoordinates, "Yarrowia lipolytica")

## Check the number of hits in each provided genomic range

length(RNAcentralHits[[1]]) # 22 known ncRNA between positions 200000 and 300000 of chromosome C
length(RNAcentralHits[[2]]) # No known ncRNA between positions 500000 and 550000 of chromosome D

```

## Predicting the secondary structure of an RNA

The "predictSecondaryStructure" function enables the prediction of the secondary
structure of RNA through three different methods: centroidFold [@hamada2008], 
centroidHomfold [@hamada2011] and IPknot [@sato2011]. IPknot has the advantage 
of being able to detect pseudoknots.

The secondary structure predictions by centroidFold and centroidHomfold are 
output in the Dot-Bracket format, where dots (".") represent unpaired bases and 
pairs of open and closed round brackets ("("-")") represent paired bases. Such 
format cannot unambiguously represent nested structures such as pseudoknots. 
Therefore, the output of IPknot is provided, if required, in the extended 
Dot-Bracket format, where additional pairs of symbols are used to represent such
nested structures.

In the following example, all three methods are used to predict the structure of
a fragment of a tRNA:

```{r tidy = TRUE}
tRNAfragment <- "UGCGAGAGGCACAGGGUUCGAUUCCCUGCAUCUCCA"

centroidFoldPrediction <- predictSecondaryStructure(tRNAfragment, "centroidFold")
centroidFoldPrediction$secondaryStructure

centroidHomFoldPrediction <- predictSecondaryStructure(tRNAfragment, "centroidHomFold")
centroidFoldPrediction$secondaryStructure

IPknotPrediction <- predictSecondaryStructure(tRNAfragment, "IPknot")
IPknotPrediction$secondaryStructure
```

It is also possible to predict not only a single canonical secondary structure, 
but also a set of possible alternative secondary structures. This is achieved 
with the RintW method [@hagio2018], available through the 
"predictAlternativeSecondaryStructures" function.

```{r tidy = TRUE}
tRNAfragment2 <- "AAAGGGGUUUCCC"

RintWPrediction <- predictAlternativeSecondaryStructures(tRNAfragment2)

length(RintWPrediction) # A total of 2 alternative secondary structures were identified by RintW

RintWPrediction[[1]]$secondaryStructure
RintWPrediction[[2]]$secondaryStructure
```

## Calculating and plotting of base pair probability matrices

Both centroidFold and centroidHomfold return not only a prediction of the 
secondary structure of an RNA, but also a list of probabilities for potential 
base pairs for each nucleotide. Such a matrix can be useful in assessing the 
potential presence of alternative secondary structures.

A matrix of base pair probabilities can be generated with the 
"generatePairsProbabilityMatrix", which takes as input the probabilities in the 
format returned by centroidFold and centroidHomFold. The base pair probabilities
matrix can then be plotted with the "plotPairsProbabilityMatrix" function:

```{r tidy = TRUE}
basePairProbabilityMatrix <- generatePairsProbabilityMatrix(centroidFoldPrediction$basePairProbabilities)

plotPairsProbabilityMatrix(basePairProbabilityMatrix)
```

A composite plot, where the top right triangle represents the base pair 
probabilities while the bottom left triangle represents base pairings in a 
specific secondary structure, can be generated with the "plotCompositePairsMatrix"
function. Usually, base pairs in a secondary structure correspond to pairs with 
a high probability. The function takes as its input a matrix of base pair 
probabilities, and a dataframe with bases paired in a given secondary structure.
Such a dataframe can be generated from a secondary structure string with the 
"findPairedBases" function.

In the following example, such a composite plot is generated the secondary
structure predicted by centroidFold for the tRNA fragment:

```{r tidy = TRUE}
pairedBases <- findPairedBases(sequence=tRNAfragment, secondaryStructureString=IPknotPrediction$secondaryStructure)

plotCompositePairsMatrix(basePairProbabilityMatrix, pairedBases)
```

## Reading and writing files and other utilities

ncRNAtools supports reading and writing files in the CT and Dot-Bracket format. 
For a description of each format, see http://projects.binf.ku.dk/pgardner/bralibase/RNAformats.html 
and https://rna.urmc.rochester.edu/Text/File_Formats.html.

CT files are read with the "readCT" function. Some CT files contain a line for 
each nucleotide of the RNA sequence, while others contain lines only for paired 
nucleotides. In the second case, the full sequence must be provided when calling 
"readCT".

The list returned by "readCT" includes an element named "pairsTable", consisting
of a dataframe indicating paired nucleotides. A corresponding secondary 
structure string in the Dot-Bracket format can be generated with the 
"pairsToSecondaryStructure" function.

CT files are written with the "writeCT" function. A complete CT file is always 
output by "writeCT".

Files in the Dot-Bracket format are read and written with the "readDotBracket" 
and "writeDotBracket" functions respectively. If the read Dot-Bracket file 
contains an energy value for the represented structure, it will be included in 
the output of "readDotBracket".

```{r tidy = TRUE}
## Read an example CT file corresponding to E. coli tmRNA

exampleCTFile <- system.file("extdata", "exampleCT.ct", package="ncRNAtools")

tmRNASequence <- "GGGGCUGAUUCUGGAUUCGACGGGAUUUGCGAAACCCAAGGUGCAUGCCGAGGGGCGGUUGGCCUCGUAAAAAGCCGCAAAAAAUAGUCGCAAACGACGAAAACUACGCUUUAGCAGCUUAAUAACCUGCUUAGAGCCCUCUCUCCCUAGCCUCCGCUCUUAGGACGGGGAUCAAGAGAGGUCAAACCCAAAAGAGAUCGCGUGGAAGCCCUGCCUGGGGUUGAAGCGUUAAAACUUAAUCAGGCUAGUUUGUUAGUGGCGUGUCCGUCCGCAGCUGGCAAGCGAAUGUAAAGACUGACUAAGCAUGUAGUACCGAGGAUGUAGGAAUUUCGGACGCGGGUUCAACUCCCGCCAGCUCCACCA"

tmRNASecondaryStructure <- readCT(exampleCTFile, tmRNASequence)

## Write a complete CT file for E. coli tmRNA

tempDir <- tempdir()
testCTFile <- paste(tempDir, "testCTfile.ct", sep="")

tmRNASecondaryStructureString <- pairsToSecondaryStructure(pairedBases=tmRNASecondaryStructure$pairsTable, sequence=tmRNASequence)

writeCT(testCTFile, sequence=tmRNASequence, 
        secondaryStructure=tmRNASecondaryStructureString, sequenceName="tmRNA")

## Read an example Dot-Bracket file

exampleDotBracketFile <- system.file("extdata", "exampleDotBracket.dot", 
                                     package="ncRNAtools")

exampleDotBracket <- readDotBracket(exampleDotBracketFile)

exampleDotBracket$freeEnergy # The structure has a free energy of -41.2 kcal/mol

## Write a Dot-Bracket file

tempDir2 <- tempdir()
testDotBracketFile <- paste(tempDir2, "testDotBracketFile.dot", sep="")

writeDotBracket(testDotBracketFile, sequence=exampleDotBracket$sequence, 
                secondaryStructure=exampleDotBracket$secondaryStructure, 
                sequenceName="Test sequence")
```

ncRNAtools includes an utility to flatten representations of secondary structure
in the extended Dot-Bracket format to basic Dot-Bracket format (i.e., comprising
only the ".", "(" and ")" characters). Although information is potentially lost 
upon such transformation, this is required for some RNA Bioinformatics software,
which can only accept secondary structures in the Dot-Bracket format as input. 
This can be achieved with the "flattenDotBracket" function.

```{r tidy = TRUE}
extendedDotBracketString <- "...((((..[[[.))))]]]..."

plainDotBracketString <- flattenDotBracket(extendedDotBracketString)
```

# Session info

```{r tidy = TRUE}
sessionInfo()
```

# References

\name{rnaCentralTextSearch}
\alias{rnaCentralTextSearch}
\title{Searches the RNAcentral database with a text query
}
\description{
Searches the RNAcentral database of non-coding RNA with a text query.
}
\usage{
rnaCentralTextSearch(query)
}
\arguments{
  \item{query}{string to be used as the text query to search the RNAcentral
  database. The most basic usage involves providing a word or group of words to
  be matched against any of the fields of entries of the RNAcentral database.
  More refined searches can be done by using the field_name:"field value" syntax.
  Several search terms can be combined with logical operators (and, or, not).
  Asterisks ("*") can be added to signal any number of any characters. If not
  added to the query, only exact matches are produced.
  A detailed description of the syntax can be found at https://rnacentral.org/help/text-search.
  The entire query should be provided as a single string, and double quotes
  enclosing field values must be escaped with a backslash (``\``).
  It should also be noted that logical operators should be capitalized.
  }
}
\value{
A character vector where each element is the RNAcentral ID of an entry that
matched the query. A maximum of 15 IDs will be returned.
}
\references{
https://rnacentral.org/about-us

https://rnacentral.org/help/text-search
}
\examples{
# Find RNAcentral entries that correspond to the HOTAIR long noncoding RNA:

rnaCentralTextSearch("HOTAIR")

# Find RNAcentral entries that correspond to FMN riboswitches in Bacillus subtilis:

rnaCentralTextSearch("FMN AND species:\"Bacillus subtilis\"")
}

\name{plotPairsProbabilityMatrix}
\alias{plotPairsProbabilityMatrix}
\title{Plots a matrix of base pair probabilities
}
\description{
Generates a heatmap-like plot to visualize the probabilities that different
bases of an RNA molecule form a pair.
}
\usage{
plotPairsProbabilityMatrix(basePairProbsMatrix, probabilityThreshold=0.1,
                           colorPalette=paste(rainbow(7, rev=TRUE), "FF", sep=""))
}
\arguments{
  \item{basePairProbsMatrix}{A symmetric square matrix containing the probabilities
  of pairs between different bases. Should be in the same format as output by
  the generatePairsProbabilityMatrix function.
  }
  \item{probabilityThreshold}{Threshold for representing the probability that
  two given bases form a pair. Pairs with a probability lower than the threshold
  will not be considered, and their corresponding cell in the plot will be left
  blank.
  }
  \item{colorPalette}{Color palette to be used for displaying the probabilities
  above the specified threshold.
  }
}
\value{
A ggplot object with a representation of the base pair probability matrix.
}
\examples{
# Load an example table of base pair probabilities, calculated with centroidFold:

basePairProbabilitiesTable <- read.csv(system.file("extdata", 
"exampleBasePairProbabilitiesTable.csv", package="ncRNAtools"))

# Generate a matrix of base pair probabilities:

probabilitiesMatrix <- generatePairsProbabilityMatrix(basePairProbabilitiesTable)

# Plot the probability matrix

plotPairsProbabilityMatrix(probabilitiesMatrix)
}

\name{plotCompositePairsMatrix}
\alias{plotCompositePairsMatrix}
\title{Plots a composite matrix of base pair probabilities and paired bases
}
\description{
Generates a heatmap-like plot to visualize the probabilities that different
bases of an RNA molecule form a pair together with bases that are paired
in a given secondary structure for the same RNA. The top-right half of the plot
represents base pair probabilities, while in the bottom-left half paired bases
are represented with black squares in the corresponding cells. Usually, a
correspondance between paired bases and high-probability base pairs is observed.
}
\usage{
plotCompositePairsMatrix(basePairProbsMatrix, pairedBases, probabilityThreshold=0.1,
                         colorPalette=paste(rainbow(7, rev=TRUE), "FF", sep=""))
}
\arguments{
  \item{basePairProbsMatrix}{A symmetric square matrix containing the probabilities
  of pairs between different bases. Should be in the same format as output by
  the generatePairsProbabilityMatrix function.
  }
  \item{pairedBases}{A dataframe indicating paired bases, in the same format as
  output by the findPairedBases function.
  }
  \item{probabilityThreshold}{Threshold for representing the probability that
  two given bases form a pair. Pairs with a probability lower than the threshold
  will not be considered, and their corresponding cell in the plot will be left
  blank.
  }
  \item{colorPalette}{Color palette to be used for displaying the probabilities
  above the specified threshold.
  }
}
\value{
A ggplot object with a representation of the base pair probability matrix and
bases paired in a given secondary structure.
}
\examples{
# Create a list with an RNA sequence, its secondary structure and a table of 
# base pair probabilities, calculated with centroidFold:

secondaryStructure <- list(sequence="GGGGAUGUAGCUCAUAUGGUAGAGCGCUCGCUUUGCAUGCGAGAGGCACAGGGUUCGAUUCCCUGCAUCUCCA", 
secondaryStructure="(((((((..((((........)))).(((((.......))))).....(((((.......)))))))))))).", 
basePairProbabilities=read.csv(system.file("extdata", "exampleBasePairProbabilitiesTable.csv", package="ncRNAtools")))

# Generate a matrix of base pair probabilities:

probabilitiesMatrix <- generatePairsProbabilityMatrix(secondaryStructure$basePairProbabilities)

# Generate a dataframe with paired bases:

pairedBases <- findPairedBases(secondaryStructure$secondaryStructure, secondaryStructure$sequence)

# Plot base pair probabilities and paired bases:

plotCompositePairsMatrix(probabilitiesMatrix, pairedBases)
}

\name{flattenDotBracket}
\alias{flattenDotBracket}
\title{Converts an extended Dot-Bracket secondary structure to basic Dot-Bracket
notation
}
\description{
Generates a string with the secondary structure of an RNA sequence in the basic
Dot-Bracket notation from a string in the extended Dot-Bracket notation.
}
\usage{
flattenDotBracket(extendedDotBracketString)
}
\arguments{
  \item{extendedDotBracketString}{A string with a secondary structure representation
  of an RNA molecule in the extended Dot-Bracket notation. The extended Dot-Bracket
  notation uses dots (".") for unpaired bases, and multiple pairs of symbols ("("-")",
  "["-"]", "{"-"}", "<"-">", "A"-"a", "B"-"b", "C"-"c" and "D"-"d") to indicate
  paired bases. This allows the format to unambiguously represent highly nested
  structures, including pseudoknots.
  }
}
\value{
A string representing the secondary structure of the provided RNA in the basic
Dot-Bracket format. In such format, dots (".") indicate unpaired bases, and
paired bases are represented with pairs of round brackets ("("-")").
}
\references{
https://www.tbi.univie.ac.at/RNA/ViennaRNA/doc/html/rna_structure_notations.html
}
\examples{
# A secondary structure string with characters other than dots and round 
# brackets, representing unambiguously pseudo-knots:

extendedDotBracketString <- "((((....((((.((((([[[[...)))))]]]]..)))).....))))."

# Convert it to the basic Dot-Bracket format:

basicDotBracketString <- flattenDotBracket(extendedDotBracketString)
}

\name{predictAlternativeSecondaryStructures}
\alias{predictAlternativeSecondaryStructures}
\title{Predicts alternative secondary structures of a given RNA sequence
}
\description{
Attempts to identify potential alternative secondary structures of the provided
RNA sequence using the RintW method, based on the decomposition of the base-pairing
probability matrix over the Hamming distance to a reference secondary structure.
It should be noted that RintW runs can take considerable amounts of time.
}
\usage{
predictAlternativeSecondaryStructures(sequence, gammaWeight=4, inferenceEngine="BL")
}
\arguments{
  \item{sequence}{string with an RNA sequence whose secondary structure should
  be predicted. Should contain only standard RNA symbols (i.e., "A", "U", "G"
  and "C").
  }
  \item{gammaWeight}{weight factor for predicted base pairs. It directly affects
  the number of predicted base pairs. A higher value leads to a higher number of
  base pairs predicted. It should be a positive number. In the default behavior,
  a value of 4 is used.
  }
  \item{inferenceEngine}{engine used to identify the optimal canonical secondary
  structure. Possible values are "BL", "Turner" and "CONTRAfold". In the first
  two cases, a McCaskill partition function is applied, using respectively the
  Boltzmann likelihood model or Turner's energy model. In the third case, the
  CONTRAfold engine, based on conditional log-linear models, is applied. In the
  default behavior, a McCaskill partition function with a Boltzmann likelihood
  model is used.
  }
}
\value{
A list of two-element lists, where each element of the upper level list represents
a potential secondary structure. The first top-level element always represents
the canonical secondary structure. If no alternative secondary structures are
found, simply a list of two elements is returned, comprising the query sequence
and the canonical secondary structure.

When alternative secondary structure elements are found, each top-level element
comprises the following two elements:
  \item{sequence }{Query RNA sequence
  }
  \item{secondaryStructure }{Predicted secondary structure
  }
}
\references{
Andronescu M, Condon A, Hoos HH, Mathews DH, Murphy KP. Computational approaches
for RNA energy parameter estimation. RNA. 2010;16(12):2304-2318.
doi:10.1261/rna.1950510

Do CB, Woods DA, Batzoglou S. CONTRAfold: RNA secondary structure prediction
without physics-based models. Bioinformatics. 2006;22(14):e90-e98.
doi:10.1093/bioinformatics/btl246

Hagio T, Sakuraba S, Iwakiri J, Mori R, Asai K. Capturing alternative secondary
structures of RNA by decomposition of base-pairing probabilities.
BMC Bioinformatics. 2018;19(Suppl 1):38. Published 2018 Feb 19.
doi:10.1186/s12859-018-2018-4

Hamada M, Ono Y, Kiryu H, et al. Rtools: a web server for various secondary
structural analyses on single RNA sequences. Nucleic Acids Res. 2016;44(W1):W302-W307.
doi:10.1093/nar/gkw337

Mathews DH, Sabina J, Zuker M, Turner DH. Expanded sequence dependence of
thermodynamic parameters improves prediction of RNA secondary structure.
J Mol Biol. 1999;288(5):911-940. doi:10.1006/jmbi.1999.2700

https://www.ncrna.org/rtools/
}
\examples{
# Predict alternative secondary structures of an RNA sequence:

alternativeStructures <- predictAlternativeSecondaryStructures("AAAGGGGUUUCCC")

# Count the number of potential alternative structures identified:

length(alternativeStructures)
}

\name{generatePairsProbabilityMatrix}
\alias{generatePairsProbabilityMatrix}
\title{Generates a matrix of base pair probabilities
}
\description{
Generates a matrix of base pair probabilities from a table of base pair
probabilities in the format returned by predictSecondaryStructure when using
centroidFold or centroidHomFold as the prediction method.
}
\usage{
generatePairsProbabilityMatrix(basePairProbsTable)
}
\arguments{
  \item{basePairProbsTable}{A dataframe where each line corresponds to a nucleotide
  of the query RNA sequence. The first column indicates the position number, the
  second column indicates the corresponding nucleotide type and additional columns
  indicating the probability of forming a base pair with other nucleotides. The
  potentially pairing nucleotides and their corresponding probabilities should be
  provided as strings, with a colon separating both fields.
  }
}
\value{
A symmetric square matrix with a number of rows and columns equal to the number
of nucleotides in the corresponding RNA sequence, determined by the number of
rows of basePairProbsTable. The names of rows and columns are the nucleotide
type and position. The value of each cell of the matrix is the probability that
the nucleotides at positions given by the row and columns of the cell form a
base pair.
}
\examples{
# Load an example table of base pair probabilities, calculated with centroidFold:

basePairProbabilitiesTable <- read.csv(system.file("extdata", 
"exampleBasePairProbabilitiesTable.csv", package="ncRNAtools"))

# Generate a base pair probability matrix from the returned base pair probability
# table:

basePairProbabilityMatrix <- generatePairsProbabilityMatrix(basePairProbabilitiesTable)
}

\name{findPairedBases}
\alias{findPairedBases}
\title{Determines paired bases from secondary structure string
}
\description{
Determines bases that form pairs in a given RNA sequence from the secondary
structure string of the RNA sequence.
}
\usage{
findPairedBases(secondaryStructureString, sequence)
}
\arguments{
  \item{secondaryStructureString}{A string representing the secondary structure
  of the RNA sequence in the Dot-Bracket format.
  }
  \item{sequence}{string with the RNA sequence corresponding to the provided
  secondary structure string. Should contain only standard RNA symbols (i.e.,
  "A", "U", "G" and "C").
  }
}
\value{
A dataframe where each row denotes a base pair. The dataframe comprises the
following 4 columns:
  \item{Position1}{position in the sequence of the nucleotide involved in the
  base pair closest to the 5' end of the RNA.
  }
  \item{Position2}{position in the sequence of the nucleotide involved in the
  base pair closest to the 3' end of the RNA.
  }
  \item{Nucleotide1}{nucleotide type of the base in Position1.
  }
  \item{Nucleotide2}{nucleotide type of the base in Position2.
  }
}
\examples{
# Read a Dot Bracket file with the secondary structure of an RNA sequence:

exampleDotBracketFile <- system.file("extdata", "exampleDotBracket.dot", 
                                     package="ncRNAtools")

exampleDotBracket <- readDotBracket(exampleDotBracketFile)

# Generate a dataframe of paired bases from the returned secondary structure
# string:

pairedBasesTable <- findPairedBases(secondaryStructureString=exampleDotBracket$secondaryStructure,
sequence=exampleDotBracket$sequence)
}

\name{readDotBracket}
\alias{readDotBracket}
\title{Reads a file with the sequence and secondary structure of an RNA in the
Dot-Bracket format
}
\description{
Reads a file with the secondary structure of an RNA in the CT format
(Connectivity Table).
}
\usage{
readDotBracket(filename)
}
\arguments{
  \item{filename}{A string indicating the path to the Dot-Bracket file to be
  read. A description of the Dot-Bracket format can be found at
  https://www.tbi.univie.ac.at/RNA/ViennaRNA/doc/html/rna_structure_notations.html.
  Both basic and extended Dot-Bracket notations are accepted. The Dot-Bracket
  file should always contain at least two lines: the first one with the RNA
  sequence, and the second one with the secondary structure representation. The
  free energy of the secondary structure can be optionally present at the end of
  the secondary structure line, in kcal/mol.
  An additional optional line can precede these two, containing ">" as its first
  character followed by the name or description of the sequence.
  }
}
\value{
A list with the following 4 elements:
  \item{sequenceName }{name of the RNA sequence. Will be set to NA if no string
  starting with ">" is present at the beginning of the Dot-Bracket file
  }
  \item{sequence }{RNA sequence
  }
  \item{secondaryStructure }{string representing the secondary structure of the
  RNA in the Dot-Bracket format
  }
  \item{freeEnergy }{free energy of the secondary structure of the RNA, usually
  in kcal/mol. If not present in the Dot-Bracket file, it will be set to NA
  }
}
\references{
https://software.broadinstitute.org/software/igv/RNAsecStructure

http://projects.binf.ku.dk/pgardner/bralibase/RNAformats.html
}
\examples{
exampleDotBracketFile <- system.file("extdata", "exampleDotBracket.dot", 
                                     package="ncRNAtools")

exampleDotBracket <- readDotBracket(exampleDotBracketFile)

# Since the file does not contain an initial line with the name of the sequence,
# sequenceName is set to NA
}

\name{readCT}
\alias{readCT}
\title{Reads a file with the secondary structure of an RNA in the CT format
}
\description{
Reads a file with the secondary structure of an RNA in the CT format
(Connectivity Table).
}
\usage{
readCT(filename, sequence=NULL)
}
\arguments{
  \item{filename}{A string indicating the path to the CT file to be read. A
  description of the CT format can be found at
  http://rna.urmc.rochester.edu/Text/File_Formats.html#CT.
  The CT file should contain information for all nucleotides of the RNA
  sequence, including those that do not form base pairs, unless the full-length
  RNA sequence is provided through the sequence argument. In such case, the CT
  file may contain only information for nucleotides involved in base pairs.
  }
  \item{sequence}{A string with the full-length sequence of the RNA whose
  secondary structure is represented in the CT file. Such argument is optional,
  but if it is not provided, a complete CT file with information for all
  nucleotides of the RNA must be provided.
  }
}
\value{
A list with the following 4 elements:
  \item{sequenceName }{name of the RNA sequence
  }
  \item{sequence }{RNA sequence
  }
  \item{sequenceLength }{number of nucleotides of the RNA sequence
  }
  \item{pairsTable }{a dataframe indicating the paired bases, in the same format
  as that returned by the findPairedBases function
  }
}
\references{
http://rna.urmc.rochester.edu/Text/File_Formats.html#CT.
}
\examples{
exampleCTFile <- system.file("extdata", "exampleCT.ct", package="ncRNAtools")

# If the CT file does not contain information for unpaired nucleotides, the
# original sequence must also be supplied in order to read it (tmRNA of E. coli 
# encoded by the ssrA gene):

tmRNASequence <- "GGGGCUGAUUCUGGAUUCGACGGGAUUUGCGAAACCCAAGGUGCAUGCCGAGGGGCGGUUGG
CCUCGUAAAAAGCCGCAAAAAAUAGUCGCAAACGACGAAAACUACGCUUUAGCAGCUUAAUAACCUGCUUAGAGCCCUCU
CUCCCUAGCCUCCGCUCUUAGGACGGGGAUCAAGAGAGGUCAAACCCAAAAGAGAUCGCGUGGAAGCCCUGCCUGGGGUU
GAAGCGUUAAAACUUAAUCAGGCUAGUUUGUUAGUGGCGUGUCCGUCCGCAGCUGGCAAGCGAAUGUAAAGACUGACUAA
GCAUGUAGUACCGAGGAUGUAGGAAUUUCGGACGCGGGUUCAACUCCCGCCAGCUCCACCA"

tmRNASecondaryStructure <- readCT(exampleCTFile, tmRNASequence)
}

\name{rnaCentralRetrieveEntry}
\alias{rnaCentralRetrieveEntry}
\title{Retrieves information for a specific entry of the RNAcentral database
}
\description{
Retrieves information for a specific entry of the RNAcentral database. The
retrieved information includes the corresponding sequence, the sequence length,
a brief description of the sequence, the species where the sequence is found,
the NCBI taxid of the species and the RNA type.
}
\usage{
rnaCentralRetrieveEntry(rnaCentralID)
}
\arguments{
  \item{rnaCentralID}{string indicating the RNAcentral ID of the entry that
  should be retrieved. It must start with "URS".
  }
}
\value{
A list containing the following elements that correspond to the RNAcentral entry
associated with the provided RNAcentral ID:
  \item{rnaCentralID }{Query RNAcentral ID
  }
  \item{sequence }{RNA sequence of the retrieved entry
  }
  \item{sequenceLength }{length of the RNA sequence of the retrieved entry
  }
  \item{description }{short description of the retrieved entry
  }
  \item{species }{species where the sequence of the retrieved entry is found
  }
  \item{ncbiTaxID }{NCBI taxonomy identifier of the species corresponding to the
  retrieved entry
  }
  \item{RNATypes }{categories of RNA associated to the RNA sequence of the
  retrieved entry
  }
}
\references{
https://rnacentral.org/about-us

https://rnacentral.org/api
}
\examples{
# Retrieve information of the RNAcentral entry associated with ID URS00007C2D83_224308:

rnaCentralEntry <- rnaCentralRetrieveEntry("URS00007C2D83_224308")

# Extract the corresponding RNA sequence

rnaCentralEntry$sequence
}

\name{writeCT}
\alias{writeCT}
\title{Writes a file with the secondary structure of an RNA in the CT format
}
\description{
Writes a file with the secondary structure of an RNA in the CT format
(Connectivity Table).
}
\usage{
writeCT(filename, sequence, secondaryStructure=NULL, sequenceName="Sequence", 
        pairedBases=NULL)
}
\arguments{
  \item{filename}{A string indicating the path to the CT file to be written. A
  description of the CT format can be found at
  http://rna.urmc.rochester.edu/Text/File_Formats.html#CT.
  }
  \item{sequence}{A string with the full-length sequence of the RNA for which
  a CT file should be written.
  }
  \item{secondaryStructure}{A string representing the secondary structure of the
  RNA sequence in the Dot-Bracket format. A correct value must be provided for
  either secondaryStructure or pairedBases. If a table of paired bases is provided
  through pairedBases, the string provided through secondaryStructure will be
  ignored. If no table of paired bases is provided, one will be internally
  calculated from the string representation of the secondary structure.
  }
  \item{sequenceName}{A string with the name of the sequence to be written in
  the first line of the CT file.
  }
  \item{pairedBases}{A table of paired bases in the same format as output by the
  findPairedBases function.
  }
}
\value{
Called for its effect of writing a CT file. Invisibly returns the status code
returned by close when closing the file connection. See documentation of close
for details.
}
\references{
http://rna.urmc.rochester.edu/Text/File_Formats.html#CT.
}
\examples{
# Write a CT file by providing an RNA sequence and its secondary structure in
# the Dot-Bracket format:

tempDir <- tempdir()
CTFile <- paste(tempDir, "testCTFile.ct", sep="")
writeCT(CTFile, "AGCGGGUUCCUGGUUCCCCAAGGUUGA", 
secondaryStructure="...(((..((.))..))).((..))..",
sequenceName="Test sequence")
}

\name{predictSecondaryStructure}
\alias{predictSecondaryStructure}
\title{Predicts the secondary structure of a given RNA sequence
}
\description{
Predicts the secondary structure of the provided RNA sequence, using the chosen
prediction method. Secondary structure predictions are carried out with the
rtools RNA Bioinformatics Web server.
}
\usage{
predictSecondaryStructure(sequence, method, gammaWeight=NULL, inferenceEngine=NULL,
alignmentEngine=NULL, eValueRfamSearch=NULL, numHomSeqsRfamSearch=NULL)
}
\arguments{
  \item{sequence}{string with an RNA sequence whose secondary structure should
  be predicted. Should contain only standard RNA symbols (i.e., "A", "U", "G"
  and "C").
  }
  \item{method}{method that should be used for the prediction of RNA secondary
  structure. Possible values are "centroidFold", "centroidHomFold" and "IPknot".
  Only IPknot is able to predict pseudoknots. For a detailed description of each
  method, see respectively \emph{Hamada et al., 2008}; \emph{Hamada et al., 2009},
  and \emph{Sato et al., 2011}.
  }
  \item{gammaWeight}{weight factor for predicted base pairs. It directly affects
  the number of predicted base pairs. A higher value leads to a higher number of
  base pairs predicted. It should be a positive number. In the default behavior,
  when no specific value is provided, the default value for each secondary
  structure prediction method in the rtools webserver is used (4 for centroidFold
  and IPknot, and 8 forcentroidHomFold).
  }
  \item{inferenceEngine}{engine used to identify optimal secondary structures.
  Possible values are "BL", "Turner" and "CONTRAfold". In the first two cases, a
  McCaskill partition function is applied, using respectively the Boltzmann
  likelihood model or Turner's energy model. In the third case, the CONTRAfold
  engine, based on conditional log-linear models, is applied. Additionally, if
  IPknot is chosen as the method for secondary structure prediction, "NUPACK" is
  also a possible value if the sequence has 100 nucleotides or less. In this case,
  the NUPACK scoring model is used. In the default behavior, when no specific
  value is provided, the default inference engine in the rtools webserver is,
  which is a McCaskill partition function with a Boltzmann likelihood model.
  }
  \item{alignmentEngine}{engine used to perform pairwise alignments of the query
  sequence and Rfam homologous sequences during the application of centroidHomFold.
  Possible values are "CONTRAlign" and "ProbCons". For details on each alignment
  engine, see \emph{Do et al., 2006} and \emph{Do et al., 2005} respectively.
  In the default behavior, when no value is specified, CONTRAlign is used.
  }
  \item{eValueRfamSearch}{e-value used to select homologous sequences from the
  Rfam database during the application of centroidHomFold. Should be a number
  equal to or greater than 0. In the default behavior, when no value is specified,
  a value of 0.01 is used.
  }
  \item{numHomSeqsRfamSearch}{maximum number of homologous sequences to be considered
  during the application of centroidHomFold. Should be a positive integer.In the
  default behavior, when no value is specified, a value of 30 is used.
  }
}
\value{
If either centroidFold or centroidHomFold are used for predicting secondary
structure, a list of three elements comprising the query RNA sequence, the predicted
secondary structure and a table of base pair probabilities. The secondary structure
is represented as a string in the Dot-Bracket format. The three elements of the list
are:
  \item{sequence }{Query RNA sequence
  }
  \item{secondaryStructure }{Predicted secondary structure
  }
  \item{basePairProbabilities }{A dataframe where each line corresponds to a nucleotide
  of the query RNA sequence. The first column indicates the position number, the
  second column indicates the corresponding nucleotide type and additional columns
  indicating the probability of forming a base pair with other nucleotides. The
  potentially pairing nucleotides and their corresponding probabilities are provided
  as strings, where a colon separates both fields
  }

If IPknot is used for predicting secondary structure, no table of base pair
probabilities is returned. Therefore, the output is a list of only two elements
(sequence and secondaryStructure). Additionally, the secondary structure is
provided in the extended Dot-Bracket format if required to represent pseudoknots
unambiguously.
}
\references{
Andronescu M, Condon A, Hoos HH, Mathews DH, Murphy KP. Computational approaches
for RNA energy parameter estimation. RNA. 2010;16(12):2304-2318.
doi:10.1261/rna.1950510

Do C.B., Gross S.S., Batzoglou S. CONTRAlign: Discriminative Training for
Protein Sequence Alignment. In: Apostolico A., Guerra C., Istrail S., Pevzner P.A.,
Waterman M. (eds) Research in Computational Molecular Biology. 2006.
Lecture Notes in Computer Science, vol 3909. Springer, Berlin, Heidelberg
doi:10.1007/11732990_15

Do CB, Mahabhashyam MS, Brudno M, Batzoglou S. ProbCons: Probabilistic
consistency-based multiple sequence alignment. Genome Res. 2005;15(2):330-340.
doi:10.1101/gr.2821705

Do CB, Woods DA, Batzoglou S. CONTRAfold: RNA secondary structure prediction
without physics-based models. Bioinformatics. 2006;22(14):e90-e98.
doi:10.1093/bioinformatics/btl246

Hamada M, Kiryu H, Sato K, Mituyama T, Asai K. Prediction of RNA secondary
structure using generalized centroid estimators. Bioinformatics. 2009;25(4):465-473.
doi:10.1093/bioinformatics/btn601

Hamada M, Ono Y, Kiryu H, et al. Rtools: a web server for various secondary
structural analyses on single RNA sequences. Nucleic Acids Res. 2016;44(W1):W302-W307.
doi:10.1093/nar/gkw337

Hamada M, Yamada K, Sato K, Frith MC, Asai K. CentroidHomfold-LAST: accurate
prediction of RNA secondary structure using automatically collected homologous
sequences. Nucleic Acids Res. 2011;39(Web Server issue):W100-W106.
doi:10.1093/nar/gkr290

Mathews DH, Sabina J, Zuker M, Turner DH. Expanded sequence dependence of
thermodynamic parameters improves prediction of RNA secondary structure.
J Mol Biol. 1999;288(5):911-940. doi:10.1006/jmbi.1999.2700

Sato K, Kato Y, Hamada M, Akutsu T, Asai K. IPknot: fast and accurate prediction
of RNA secondary structures with pseudoknots using integer programming.
Bioinformatics. 2011;27(13):i85-i93. doi:10.1093/bioinformatics/btr215

https://www.ncrna.org/rtools/
}
\examples{
# Predict the secondary structure of an RNA sequence with IPknot:

structurePrediction <- predictSecondaryStructure("UGCGAGAGGCACAGGGUUCGAUUCCCUGCA
UCUCCA", "IPknot", inferenceEngine = "NUPACK")

# Extract the string representing the secondary structure prediction:

structurePrediction$secondaryStructure
}

\name{pairsToSecondaryStructure}
\alias{pairsToSecondaryStructure}
\title{Generates a string with the secondary structure of an RNA sequence
}
\description{
Generates a string with the secondary structure of an RNA sequence from a
table of paired bases.
}
\usage{
pairsToSecondaryStructure(pairedBases, sequence)
}
\arguments{
  \item{pairedBases}{A dataframe where each row contains the information of two
  bases that form a pair. The dataframe should contain columns named "Position1"
  and "Position2" indicating respectively the positions of the  5' and 3' bases
  involved in the base pair.
  }
  \item{sequence}{string with the RNA sequence corresponding to the provided
  table of paired bases. Should contain only standard RNA symbols (i.e., "A",
  "U", "G" and "C"), and no spaces or newlines.
  }
}
\value{
A string representing the secondary structure of the provided RNA in the Dot-Bracket
format.
}
\examples{
# Read a Dot Bracket file with the secondary structure of an RNA sequence:

exampleDotBracketFile <- system.file("extdata", "exampleDotBracket.dot", 
                                     package="ncRNAtools")

exampleDotBracket <- readDotBracket(exampleDotBracketFile)

# Generate a dataframe of paired bases from the returned secondary structure
# string:

pairedBasesTable <- findPairedBases(secondaryStructureString=exampleDotBracket$secondaryStructure,
sequence=exampleDotBracket$sequence)

# Generate a secondary structure string from the table of paired bases:

secondaryStructureString <- pairsToSecondaryStructure(pairedBasesTable,
exampleDotBracket$sequence)

# Verify that the resulting secondary structure string is equal to the original
# prediction:

secondaryStructureString == exampleDotBracket$secondaryStructure
}

\name{rnaCentralGenomicCoordinatesSearch}
\alias{rnaCentralGenomicCoordinatesSearch}
\title{Retrieves annotated non-coding RNA in a set of genomic ranges
}
\description{
Retrieves RNAcentral entries corresponding to non-coding RNA present within
a specified set of genomic coordinates
}
\usage{
rnaCentralGenomicCoordinatesSearch(genomicRanges, species)
}
\arguments{
  \item{genomicRanges}{GRanges object specifying the genomic coordinates for
  which known non-coding RNA should be retrieved. Each sequence name must be of
  the format chr? or simply ?, where ? can be any number or the "X" or "Y"
  characters. These denote, respectively, standard somatic chromosomes and
  sexual chromosomes. Additionally, sequence name can also be "MT", which refers
  to the mitochondrial DNA. Multiple ranges can be provided in the same GRanges
  object, but they must all belong to the same organism.
  }
  \item{species}{string specifying the species to which the ranges supplied with
  the genomicRanges argument refer. The scientific name should be provided. The
  list of species for which search of RNAcentral by genomic coordinates is
  supported can be found at https://rnacentral.org/help/genomic-mapping.
  }
}
\value{
A nested list whose length matches the number of genomic ranges provided through
genomicRanges. Each top-level element is a list containing all hits found for
a given genomic range. In turn, each of the elements of such list representing
a hit is a list comprising the following elements that describe the hit:
  \item{rnaCentralID }{RNAcentral ID of the non-coding RNA that was identified
  as a hit
  }
  \item{species }{species whose genome was searched
  }
  \item{description }{brief description of the RNA sequence of the hit
  }
  \item{RNAType }{category of the RNA sequence of the hit
  }
  \item{genomicCoordinates }{GRanges object containing a single range, within
  which the hit was found
  }
}
\references{
https://rnacentral.org/help/genomic-mapping

https://rnacentral.org/api
}
\examples{
# Generate a GRanges object with 2 genomic ranges specifying coordinates of
# the human genome:

genomicCoordinates <- GenomicRanges::GRanges(seqnames=S4Vectors::Rle(c("chr3", "chr4")),
ranges=IRanges::IRanges(rep(39745816, 2), rep(39847679, 2)))

# Retrieve known annotated non-coding RNA present in the specified genomic
# ranges:

knownNonCodingRNA <- rnaCentralGenomicCoordinatesSearch(genomicCoordinates, "Homo sapiens")
}

\name{writeDotBracket}
\alias{writeDotBracket}
\title{Writes a file with the sequence and secondary structure of an RNA in the
Dot-Bracket format
}
\description{
Writes a file with the sequence and secondary structure of an RNA in the
Dot-Bracket format.
}
\usage{
writeDotBracket(filename, sequence, secondaryStructure, sequenceName="Sequence")
}
\arguments{
  \item{filename}{A string indicating the path to the Dot-Bracket file to be
  written. A description of the Dot-Bracket format can be found at
  https://www.tbi.univie.ac.at/RNA/ViennaRNA/doc/html/rna_structure_notations.html.
  The resulting file will contain three lines. The first line starts with ">",
  after which the name of the sequence follows. The second line contains the RNA
  sequence. The third line contains the secondary structure representation in
  Dot-Bracket notation.
  }
  \item{sequence}{A string with the full-length sequence of the RNA for which
  a Dot-Bracket file should be written.
  }
  \item{secondaryStructure}{A string representing the secondary structure of the
  RNA sequence in the Dot-Bracket format.
  }
  \item{sequenceName}{A string with the name of the RNA sequence for which
  a Dot-Bracket file should be written.
  }
}
\value{
Called for its effect of writing a Dot-Bracket file. Invisibly returns the status
code returned by close when closing the file connection. See documentation of close
for details.
}
\references{
https://software.broadinstitute.org/software/igv/RNAsecStructure

http://projects.binf.ku.dk/pgardner/bralibase/RNAformats.html
}
\examples{
# Write a Dot-Bracket file by providing an RNA sequence and its secondary structure in
# the Dot-Bracket format:

tempDir <- tempdir()
DotBracketFile <- paste(tempDir, "testDotBracketFile.dot", sep="")
writeDotBracket(DotBracketFile, "AGCGGGUUCCUGGUUCCCCAAGGUUGA",
secondaryStructure="...(((..((.))..))).((..))..", sequenceName="Test sequence")
}
